const fs = require('fs')
const path = require('path')
const area = require('./lib/regions/areaData.json')
const Pinyin = require('pinyin')

function nameToPinyin (name) {
  return Pinyin(name, {
    style: Pinyin.STYLE_NORMAL
  }).map(e => e[0].charAt(0).toUpperCase() + e[0].slice(1))
  .join('')
}

let dartStr = `enum AreaType {province, city, area}

class AreaItem {
  final String id;
  final String name;
  final AreaType type;
  final String pinyin;

  const AreaItem(this.id, this.name, this.type, this.pinyin);
}

const List<AreaItem> AreaData = [
`

for (let i in area.province) {
  let name = area.province[i]
  dartStr += `  AreaItem('${i}', '${name}', AreaType.province, '${nameToPinyin(name)}'),\r\n`
}
for (let i in area.city) {
  let name = area.city[i]
  dartStr += `  AreaItem('${i}', '${name}', AreaType.city, '${nameToPinyin(name)}'),\r\n`
}
for (let i in area.area) {
  let name = area.area[i]
  dartStr += `  AreaItem('${i}', '${name}', AreaType.area, '${nameToPinyin(name)}'),\r\n`
}

dartStr += '];'
fs.writeFileSync(path.resolve(__dirname, './lib/regions/area_data.dart') ,dartStr)