import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter_focus_watcher/flutter_focus_watcher.dart';

class TkPage extends StatefulWidget {
  final Widget child;
  final bool extendBody;
  final bool extendBodyBehindAppBar;
  final PreferredSizeWidget appBar;
  final Widget floatingActionButton;
  final FloatingActionButtonLocation floatingActionButtonLocation;
  final FloatingActionButtonAnimator floatingActionButtonAnimator;
  final List<Widget> persistentFooterButtons;
  final Widget drawer;
  final Widget endDrawer;
  final Color drawerScrimColor;
  final Color backgroundColor;
  final Widget bottomNavigationBar;
  final Widget bottomSheet;
  final DragStartBehavior drawerDragStartBehavior;
  final double drawerEdgeDragWidth;
  final bool primary;
  final bool resizeToAvoidBottomPadding;

  TkPage(
      {Key key,
      this.child,
      this.extendBody = false,
      this.extendBodyBehindAppBar = false,
      this.appBar,
      this.floatingActionButton,
      this.floatingActionButtonLocation,
      this.floatingActionButtonAnimator,
      this.persistentFooterButtons,
      this.drawer,
      this.endDrawer,
      this.drawerScrimColor,
      this.backgroundColor,
      this.bottomNavigationBar,
      this.bottomSheet,
      this.primary = true,
      this.drawerDragStartBehavior = DragStartBehavior.start,
      this.resizeToAvoidBottomPadding,
      this.drawerEdgeDragWidth})
      : super(key: key);

  @override
  _PageState createState() => _PageState();
}

class _PageState extends State<TkPage> {
  @override
  Widget build(BuildContext context) {
    return FocusWatcher(
      child: Scaffold(
          resizeToAvoidBottomPadding: widget.resizeToAvoidBottomPadding,
          extendBody: widget.extendBody,
          extendBodyBehindAppBar: widget.extendBodyBehindAppBar,
          appBar: widget.appBar,
          floatingActionButton: widget.floatingActionButton,
          floatingActionButtonAnimator: widget.floatingActionButtonAnimator,
          floatingActionButtonLocation: widget.floatingActionButtonLocation,
          persistentFooterButtons: widget.persistentFooterButtons,
          drawer: widget.drawer,
          endDrawer: widget.endDrawer,
          drawerScrimColor: widget.drawerScrimColor,
          backgroundColor: widget.backgroundColor,
          bottomNavigationBar: widget.bottomNavigationBar,
          bottomSheet: widget.bottomSheet,
          drawerDragStartBehavior: widget.drawerDragStartBehavior,
          resizeToAvoidBottomInset: false,
          drawerEdgeDragWidth: widget.drawerEdgeDragWidth,
          primary: widget.primary,
          body: SafeArea(
            child: widget.child,
          )),
    );
  }
}
